//******************************************************************************
// 
//                 UNIT UPRINCIPAL (-)
// 
//******************************************************************************
// Project:        ECF99 verso para LINUX
// File:           uPrincipal.pas
// Directory:      C:\projetos\cupom\source\
// Function:       ..
// Description:    ..
// Author:         Charles Alves
// Environment:    Kylix 1 Open Edition, Celerom 333, 64MB, Linux Mandrake 8
// Compiled state: Delphi Compiled Unit: uPrincipal.dcu
// Resources:      Win32 API
// Notes:          ..
// Revisions:      
// 
// 01.00.00 03/10/2001
// 
//******************************************************************************

unit uPrincipal;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QComCtrls, QExtCtrls, QMask, QButtons, Libc;


type
  TfrmPrincipal = class(TForm)
    Label1: TLabel;
    edCaminho: TEdit;
    Panel2: TPanel;
    edEnviado: TEdit;
    edRecebido: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    Panel1: TPanel;
    PageControl1: TPageControl;
    tsEsc01: TTabSheet;
    Label2: TLabel;
    Label3: TLabel;
    edCodigo: TEdit;
    edQuant: TEdit;
    edPreco: TEdit;
    Label4: TLabel;
    edTotal: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    edDesc: TEdit;
    Label7: TLabel;
    mskAliquota: TMaskEdit;
    Label8: TLabel;
    mskTamcod: TMaskEdit;
    Label9: TLabel;
    edDescrA: TEdit;
    BitBtn1: TBitBtn;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    TabSheet9: TTabSheet;
    TabSheet10: TTabSheet;
    TabSheet11: TTabSheet;
    TabSheet12: TTabSheet;
    BitBtn6: TBitBtn;
    cbLX: TCheckBox;
    TabSheet13: TTabSheet;
    BitBtn7: TBitBtn;
    cbRZ: TCheckBox;
    TabSheet14: TTabSheet;
    TabSheet15: TTabSheet;
    TabSheet16: TTabSheet;
    Label12: TLabel;
    edCNPJ: TEdit;
    BitBtn2: TBitBtn;
    TabSheet17: TTabSheet;
    TabSheet18: TTabSheet;
    TabSheet19: TTabSheet;
    TabSheet20: TTabSheet;
    TabSheet21: TTabSheet;
    TabSheet22: TTabSheet;
    Label13: TLabel;
    BitBtn3: TBitBtn;
    TabSheet23: TTabSheet;
    TabSheet24: TTabSheet;
    TabSheet25: TTabSheet;
    TabSheet26: TTabSheet;
    rgTipo27: TRadioGroup;
    TabSheet27: TTabSheet;
    Label14: TLabel;
    BitBtn4: TBitBtn;
    BitBtn8: TBitBtn;
    Label15: TLabel;
    edDescItemTexto: TEdit;
    edDescItemValor: TEdit;
    Label16: TLabel;
    Label17: TLabel;
    edDescSubText: TEdit;
    edDescSubValor: TEdit;
    Label18: TLabel;
    BitBtn9: TBitBtn;
    cbImpSub: TCheckBox;
    Label19: TLabel;
    edItem: TEdit;
    btnEnviaSemParametro: TBitBtn;
    Label20: TLabel;
    BitBtn12: TBitBtn;
    Label21: TLabel;
    edCodigoLegenda: TEdit;
    Label22: TLabel;
    edDescLeg: TEdit;
    Label23: TLabel;
    edValorLegenda: TEdit;
    Label24: TLabel;
    edTNF: TEdit;
    BitBtn13: TBitBtn;
    rgAtribTNF: TRadioGroup;
    Label25: TLabel;
    edCodModa: TEdit;
    edValorModa: TEdit;
    Label26: TLabel;
    Label27: TLabel;
    edTexto1: TEdit;
    edTexto2: TEdit;
    BitBtn14: TBitBtn;
    BitBtn15: TBitBtn;
    edEnviaModa: TEdit;
    Label28: TLabel;
    BitBtn16: TBitBtn;
    Label30: TLabel;
    edValorAcre: TEdit;
    cbTipoAcr: TComboBox;
    Label29: TLabel;
    Label31: TLabel;
    edPctAcre: TEdit;
    Label32: TLabel;
    cbAcreSub: TCheckBox;
    BitBtn17: TBitBtn;
    Panel3: TPanel;
    cbVinculado: TCheckBox;
    cbSeg: TCheckBox;
    BitBtn5: TBitBtn;
    TabSheet28: TTabSheet;
    TabSheet29: TTabSheet;
    cbSemPara: TCheckBox;
    Label33: TLabel;
    Label34: TLabel;
    edRedIn: TEdit;
    edRedFin: TEdit;
    BitBtn19: TBitBtn;
    Label35: TLabel;
    Label36: TLabel;
    BitBtn20: TBitBtn;
    mskDataInicio: TMaskEdit;
    mskDataFinal: TMaskEdit;
    BitBtn21: TBitBtn;
    Label37: TLabel;
    BitBtn22: TBitBtn;
    Label38: TLabel;
    EdTitulo: TEdit;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    edCOO: TEdit;
    edTipoModal: TEdit;
    edIdentificacao: TEdit;
    bitCancelaItem: TBitBtn;
    BitBtn10: TBitBtn;
    Label42: TLabel;
    Label43: TLabel;
    BitBtn23: TBitBtn;
    Label44: TLabel;
    BitBtn24: TBitBtn;
    Label45: TLabel;
    BitBtn25: TBitBtn;
    rgTipo29: TRadioGroup;
    BitBtn26: TBitBtn;
    edAtrib1: TEdit;
    edLinha1: TEdit;
    edAtrib2: TEdit;
    edLinha2: TEdit;
    edAtrib3: TEdit;
    edLinha3: TEdit;
    edAtrib4: TEdit;
    edLinha4: TEdit;
    edAtrib5: TEdit;
    edLinha5: TEdit;
    edAtrib6: TEdit;
    edLinha6: TEdit;
    edLinha7: TEdit;
    edAtrib7: TEdit;
    edAtrib8: TEdit;
    edLinha8: TEdit;
    BitBtn18: TBitBtn;
    Label46: TLabel;
    edAtribAut: TEdit;
    cbLogo: TCheckBox;
    Label47: TLabel;
    edAutCod: TEdit;
    Label48: TLabel;
    edAutCab: TEdit;
    cbLiquido: TCheckBox;
    BitBtn11: TBitBtn;
    Label49: TLabel;
    edBanco: TEdit;
    edValorCheque: TEdit;
    Label50: TLabel;
    cbVersoCheque: TCheckBox;
    Label51: TLabel;
    edLinhaCheque1: TEdit;
    Label52: TLabel;
    edLinhaCheque2: TEdit;
    Label53: TLabel;
    rgDigitosCheque: TRadioGroup;
    mskDataCheque: TMaskEdit;
    Label54: TLabel;
    BitBtn27: TBitBtn;
    Label55: TLabel;
    edECF: TEdit;
    cbCentavos: TCheckBox;
    cbTitulo: TCheckBox;
    cbCifrao: TCheckBox;
    Label56: TLabel;
    edCifrao: TEdit;
    BitBtn28: TBitBtn;
    Label57: TLabel;
    edIntervalo: TEdit;
    TabSheet30: TTabSheet;
    TabSheet32: TTabSheet;
    TabSheet33: TTabSheet;
    TabSheet34: TTabSheet;
    TabSheet31: TTabSheet;
    TabSheet35: TTabSheet;
    TabSheet36: TTabSheet;
    TabSheet37: TTabSheet;
    TabSheet38: TTabSheet;
    BitBtn29: TBitBtn;
    edSalto: TEdit;
    Label58: TLabel;
    cbClicheSegundo: TCheckBox;
    edClicheAtrib1: TEdit;
    edCliche1: TEdit;
    edClicheAtrib2: TEdit;
    edCliche2: TEdit;
    edClicheAtrib3: TEdit;
    edCliche3: TEdit;
    edClicheAtrib4: TEdit;
    edCliche4: TEdit;
    Label59: TLabel;
    Label60: TLabel;
    Label61: TLabel;
    Label62: TLabel;
    Label63: TLabel;
    Label64: TLabel;
    edClicheAtrib5: TEdit;
    edCliche5: TEdit;
    Label65: TLabel;
    edTaxaIdent: TEdit;
    edAliquota: TEdit;
    Label66: TLabel;
    Label67: TLabel;
    edFormatoAliquota: TEdit;
    Label68: TLabel;
    BitBtn30: TBitBtn;
    BitBtn31: TBitBtn;
    BitBtn32: TBitBtn;
    Label69: TLabel;
    Label70: TLabel;
    Label71: TLabel;
    edCadCNPJ: TEdit;
    edCadIE: TEdit;
    edCadIM: TEdit;
    BitBtn33: TBitBtn;
    BitBtn34: TBitBtn;
    Label72: TLabel;
    Label73: TLabel;
    mskAcertaData: TMaskEdit;
    mskAcertaHora: TMaskEdit;
    BitBtn35: TBitBtn;
    cbHoraVerao: TCheckBox;
    cbZerar: TCheckBox;
    edLegNF: TEdit;
    Label74: TLabel;
    edFormatoNF: TEdit;
    Label75: TLabel;
    BitBtn36: TBitBtn;
    BitBtn37: TBitBtn;
    BitBtn38: TBitBtn;
    Label76: TLabel;
    edNomeModa: TEdit;
    Label77: TLabel;
    edNomeFormatoModa: TEdit;
    BitBtn39: TBitBtn;
    BitBtn40: TBitBtn;
    BitBtn41: TBitBtn;
    cbConfirmaComando: TCheckBox;
    BitBtn43: TBitBtn;
    TabSheet39: TTabSheet;
    TabSheet40: TTabSheet;
    TabSheet41: TTabSheet;
    TabSheet42: TTabSheet;
    TabSheet43: TTabSheet;
    TabSheet44: TTabSheet;
    Label78: TLabel;
    BitBtn42: TBitBtn;
    Label79: TLabel;
    BitBtn44: TBitBtn;
    BitBtn45: TBitBtn;
    Label80: TLabel;
    edFavorecido: TEdit;
    Label81: TLabel;
    edMunicipio: TEdit;
    Label82: TLabel;
    edMoeda: TEdit;
    edMoedas: TEdit;
    Label83: TLabel;
    TabSheet45: TTabSheet;
    Label84: TLabel;
    edBancoCheque: TEdit;
    Label85: TLabel;
    Label86: TLabel;
    edLValor: TEdit;
    edCValor: TEdit;
    edCextenso1: TEdit;
    edExtenso1: TEdit;
    edCextenso2: TEdit;
    edExtenso2: TEdit;
    edCfavorecido: TEdit;
    edLfavorecido: TEdit;
    edCmunicipio: TEdit;
    edLmunicipio: TEdit;
    Label87: TLabel;
    Label88: TLabel;
    Label89: TLabel;
    Label90: TLabel;
    Label91: TLabel;
    cbMValor: TCheckBox;
    cbMLinha2: TCheckBox;
    cbMFavorecido: TCheckBox;
    cbMMunicipio: TCheckBox;
    cbMlinha1: TCheckBox;
    Label92: TLabel;
    edCDia: TEdit;
    edCmes: TEdit;
    edCano: TEdit;
    Label93: TLabel;
    Label94: TLabel;
    Label95: TLabel;
    BitBtn46: TBitBtn;
    cbBanco: TCheckBox;
    ednumero: TEdit;
    Label96: TLabel;
    BitBtn47: TBitBtn;
    rgNF: TRadioGroup;
    Label97: TLabel;
    edTituloNF: TEdit;
    Label98: TLabel;
    edLegNF47: TEdit;
    Label99: TLabel;
    edNovaLeg47: TEdit;
    BitBtn48: TBitBtn;
    BitBtn49: TBitBtn;
    BitBtn50: TBitBtn;
    edFormatoNF47: TEdit;
    cbImediata: TCheckBox;
    cbAbrev: TCheckBox;
    cbBidi: TCheckBox;
    cbTroco: TCheckBox;
    BitBtn51: TBitBtn;
    BitBtn52: TBitBtn;
    edFormatoLogo: TEdit;
    BitBtn53: TBitBtn;
    Label100: TLabel;
    edAtribIndic: TEdit;
    Label101: TLabel;
    edTipoIndic: TEdit;
    Label102: TLabel;
    Label103: TLabel;
    BitBtn54: TBitBtn;
    BitBtn55: TBitBtn;
    BitBtn56: TBitBtn;
    edFormatoIndic: TEdit;
    edIdentIndic: TEdit;
    procedure BitBtn1Click(Sender: TObject);
    procedure edPrecoExit(Sender: TObject);
    procedure edPrecoKeyPress(Sender: TObject; var Key: Char);
    procedure edQuantExit(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure edDescItemValorExit(Sender: TObject);
    procedure BitBtn9Click(Sender: TObject);
    procedure edItemKeyPress(Sender: TObject; var Key: Char);
    procedure edItemExit(Sender: TObject);
    procedure btnEnviaSemParametroClick(Sender: TObject);
    procedure BitBtn12Click(Sender: TObject);
    procedure BitBtn13Click(Sender: TObject);
    procedure BitBtn14Click(Sender: TObject);
    procedure BitBtn16Click(Sender: TObject);
    procedure edCodModaExit(Sender: TObject);
    procedure BitBtn15Click(Sender: TObject);
    procedure BitBtn17Click(Sender: TObject);
    procedure BitBtn18Click(Sender: TObject);
    procedure edAtrib1Exit(Sender: TObject);
    procedure BitBtn19Click(Sender: TObject);
    procedure edRedInExit(Sender: TObject);
    procedure BitBtn20Click(Sender: TObject);
    procedure bitCancelaItemClick(Sender: TObject);
    procedure BitBtn22Click(Sender: TObject);
    procedure BitBtn26Click(Sender: TObject);
    procedure BitBtn11Click(Sender: TObject);
    procedure BitBtn27Click(Sender: TObject);
    procedure BitBtn28Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn29Click(Sender: TObject);
    procedure BitBtn30Click(Sender: TObject);
    procedure BitBtn31Click(Sender: TObject);
    procedure BitBtn32Click(Sender: TObject);
    procedure BitBtn33Click(Sender: TObject);
    procedure BitBtn34Click(Sender: TObject);
    procedure BitBtn35Click(Sender: TObject);
    procedure BitBtn36Click(Sender: TObject);
    procedure BitBtn38Click(Sender: TObject);
    procedure BitBtn37Click(Sender: TObject);
    procedure BitBtn40Click(Sender: TObject);
    procedure BitBtn41Click(Sender: TObject);
    procedure BitBtn39Click(Sender: TObject);
    procedure BitBtn43Click(Sender: TObject);
    procedure BitBtn45Click(Sender: TObject);
    procedure BitBtn46Click(Sender: TObject);
    procedure BitBtn47Click(Sender: TObject);
    procedure BitBtn48Click(Sender: TObject);
    procedure BitBtn49Click(Sender: TObject);
    procedure BitBtn50Click(Sender: TObject);
    procedure BitBtn51Click(Sender: TObject);
    procedure BitBtn53Click(Sender: TObject);
    procedure BitBtn52Click(Sender: TObject);
    procedure BitBtn54Click(Sender: TObject);
    procedure BitBtn55Click(Sender: TObject);
    procedure BitBtn56Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    //--> Esta funo realiza o envio do comando e
    //--> a captura das respostas para a impressora.
    //--> Os comandos enviados devem sempre seguir o
    //--> formato <ESC>.99} onde,
    //-->  <ESC> -  o caracter esc
    //-->  99    -  o nmero do comando
    //-->  }     -  a finalizao do comando Sweda.
    function EnviaComando(strComando:String):String;
  end;


  function NoSpace(strTexto:String; cChar:Char ):String;
  procedure LimpaCampos(obj:TTabSheet);

var
  frmPrincipal: TfrmPrincipal;

implementation

uses uLogo;

{$R *.xfm}
function TfrmPrincipal.EnviaComando(strComando:String):String;
var
   Arq:TextFile;
   strResposta:string;
   tTempo:Extended;
begin
     edEnviado.Text := strcomando;

     //--> Apaga o arquivo de resposta.
     DeleteFile(edCaminho.Text +'eq.RSP');

     //--> Grava no arquivo para enviar para a impressora.
     AssignFile(Arq,edCaminho.Text + 'eq.MSG');
     Rewrite(Arq);
     Writeln(Arq,format('%s.%s}',[chr(27),strComando]));
     CloseFile(Arq);

     //--> Pega a hora atual.
     tTempo :=  Time;

     //--> Aguarda a resposta da impressora.
     while not FileExists(edCaminho.Text +'eq.RSP') do
     begin
          //--> Este  o time-out da espera pelo arquivo
          //--> de resposta. Caso o arquivo no seja criado
          //--> em 5 segundos, esta funo retorna .-p006}
          if (Time - tTempo) >=  StrToTime('00:00:05') then
          begin
               strResposta := '.-P006}';
               Result := strResposta;
               //--> Apaga o arquivo de resposta.
               DeleteFile(edCaminho.Text +'eq.RSP');
               exit;
          end;
     end;

     //--> Muda a permisso do arquivo de resposta.
     if chmod(pchar(Format('%seq.RSP',[edCaminho.text])), 511) = -1 then
        Application.MessageBox('Erro ao mudar os direitos do arquivo de resposta','',[smbOk],smsInformation) ;


     AssignFile(Arq,edCaminho.Text + 'eq.RSP');
     Reset(Arq);
     Readln(Arq,strResposta);
     CloseFile(arq);

     //-->Apaga o arquivo de resposta.
     DeleteFile(edCaminho.Text +'eq.RSP');

     Result := strResposta;
end;

procedure TfrmPrincipal.BitBtn1Click(Sender: TObject);
var
   strTamcod:string;
begin
     if (mskTamcod.Text = '') or (mskTamcod.Text = '00') then
        strTamcod := ''
        else
            strTamcod := mskTamcod.Text;
     //--> alguns comandos precisam ser formatados para preencher a quantidade
     //--> correta de dgitos.
     //--> Procure no help do delphi sobre a funo Format para entender melhor
     //--> o seu funcionamento.
     if edDescrA.Text <> '' then
        edRecebido.Text := EnviaComando(Format(#27'.01%13s%.7d%.9d%.12d%-24s%-3s%-40s}',
                                        [edCodigo.text,
                                         StrToIntDef(NoSpace(edQuant.text,','),0),
                                         StrToIntDef(NoSpace(edPreco.text,','),0),
                                         StrToIntDef(NoSpace(edtotal.text,','),0),
                                         edDesc.text,
                                         mskAliquota.text,
                                         edDescrA.text]))
        else
            edRecebido.Text := EnviaComando(Format(#27'.01%13s%.7d%.9d%.12d%-24s%-3s%s}',
                                            [edCodigo.text,
                                             StrToIntDef(NoSpace(edQuant.text,','),0),
                                             StrToIntDef(NoSpace(edPreco.text,','),0),
                                             StrToIntDef(NoSpace(edtotal.text,','),0),
                                             edDesc.text,mskAliquota.text,
                                             strTamcod]));


end;

procedure TfrmPrincipal.edPrecoExit(Sender: TObject);
var
   strFormato:string;
begin
     strformato := '0.00';

     if Trim(TEdit(Sender).Text) = '' then
        TEdit(Sender).Text := '0';

     if TEdit(Sender).Name = 'edPreco' then
        if Length(edDesc.text) > 0 then
           case ord(edDesc.Text[1]) of
                 Ord('>'),
                 Ord(']'),
                 Ord('|'),
                 Ord('~') : strFormato := '0.000';
        end;

     TEdit(Sender).Text := FormatFloat(strFormato,StrToFloat(NoSpace(TEdit(Sender).Text,' ')));
end;

function NoSpace(strTexto:String; cChar:Char ):String;
begin
     while Pos(cChar,strTexto) > 0 do
          Delete(strTexto,Pos(cChar,strTexto),1);
     result := strTexto;
end;

procedure TfrmPrincipal.edPrecoKeyPress(Sender: TObject; var Key: Char);
begin
     if ord(key) = 8 then
        Exit;
     if Key = '.' then
        Key := ',';

     if not (Key in ['0','1','2','3','4','5','6','7','8','9',',']) then
        Key := #0;
end;

procedure TfrmPrincipal.edQuantExit(Sender: TObject);
begin
     if Trim(TEdit(Sender).Text) = '' then
        TEdit(Sender).Text := '0';
     TEdit(Sender).Text := FormatFloat('0.000',StrToFloat(NoSpace(TEdit(Sender).Text,' ')));
end;

procedure TfrmPrincipal.BitBtn2Click(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(Format(#27'.17%20.s}',[edCNPJ.Text] ))
end;

procedure TfrmPrincipal.BitBtn5Click(Sender: TObject);
begin
     if (rgTipo27.ItemIndex >= 0) and (rgTipo27.ItemIndex < 9) then
        edRecebido.Text :=  EnviaComando(#27'.27' + IntToStr(rgTipo27.ItemIndex + 1) + '}')
        else
            edRecebido.Text :=  EnviaComando(#27'.27' + char(rgTipo27.ItemIndex + 56) + '}');
end;

procedure TfrmPrincipal.BitBtn6Click(Sender: TObject);
var
   strGer:string;
begin
     if cbLX.Checked then
        strGer := 'S'
        else
            strGer := 'N';

     edRecebido.Text := EnviaComando(#27'.13'+ strGer +'}');
end;

procedure TfrmPrincipal.BitBtn7Click(Sender: TObject);
var
   strGer:string;
begin
     if cbRZ.Checked then
        strGer := 'S'
        else
            strGer := 'N';
     edRecebido.Text := EnviaComando(#27'.14'+ strGer +'}');
end;

procedure TfrmPrincipal.BitBtn8Click(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(Format(#27'.02%10s%.12d}',
                                     [ edDescItemTexto.text,
                                      StrToIntDef(NoSpace(edDescItemValor.text,','),0)
                                     ]));
end;

procedure TfrmPrincipal.edDescItemValorExit(Sender: TObject);
begin
     if Trim(TEdit(Sender).Text) = '' then
        TEdit(Sender).Text := '0';
     TEdit(Sender).Text := FormatFloat('0.00',StrToFloat(NoSpace(TEdit(Sender).Text,' ')));
end;

procedure TfrmPrincipal.BitBtn9Click(Sender: TObject);
var strSub:string;
begin
     if cbImpSub.Checked then
        strSub := 'S'
        else
            strSub := 'N';
     edRecebido.Text := EnviaComando(Format(#27'.03%10s%.12d%s}',
                                     [edDescSubText.text,
                                      StrToIntDef(NoSpace(edDescSubValor.text,','),0),
                                      strSub
                                     ]));
end;

procedure TfrmPrincipal.edItemKeyPress(Sender: TObject; var Key: Char);
begin
     if ord(key) = 8 then
        Exit;
     if not (Key in ['0','1','2','3','4','5','6','7','8','9']) then
        Key := #0;
end;

procedure TfrmPrincipal.edItemExit(Sender: TObject);
begin
     if Trim(TEdit(Sender).Text) = '' then
        TEdit(Sender).Text := '0';

     TEdit(Sender).Text := FormatFloat('000',StrToFloat(NoSpace(TEdit(Sender).Text,' ')));
end;

procedure TfrmPrincipal.BitBtn12Click(Sender: TObject);
begin
   edRecebido.Text := EnviaComando(Format(#27'.07%.2d%.12d%-40s}',
                                    [StrToIntDef(edCodigoLegenda.text,0),
                                     StrToIntDef(NoSpace(edValorLegenda.text,','),0),
                                     edDescLeg.Text
                                     ]));
   edCodigoLegenda.SetFocus;
end;

procedure TfrmPrincipal.BitBtn13Click(Sender: TObject);
var
   strAtrib:string;
begin
     case rgAtribTNF.ItemIndex of
          0:
          begin
                 edRecebido.text := EnviaComando(#27'.08}');
                 exit;
          end;
          1:strAtrib := '0';
          2:strAtrib := '1';
          3:strAtrib := '2';
          4:strAtrib := '9';
     end;
     edRecebido.text := EnviaComando(Format(#27'.08%s%-40s}',[strAtrib,
                                      edTNF.text]));
     edTNF.SetFocus;
end;

procedure TfrmPrincipal.BitBtn14Click(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(#27'.10' + edEnviaModa.Text + '}');
end;

procedure TfrmPrincipal.BitBtn16Click(Sender: TObject);
begin
     edEnviaModa.Clear;
end;

procedure TfrmPrincipal.edCodModaExit(Sender: TObject);
begin
     if Trim(TEdit(Sender).Text) = '' then
        TEdit(Sender).Text := '0';
     TEdit(Sender).Text := FormatFloat('00',StrToFloat(NoSpace(TEdit(Sender).Text,' ')));
end;

procedure TfrmPrincipal.BitBtn15Click(Sender: TObject);
begin
     if NoSpace(edTexto1.Text + edTexto2.Text ,' ') = '' then
        edEnviaModa.Text := edEnviaModa.Text + Format('%.2d%.12d',[
                                                      StrtoIntDef(NoSpace(edCodModa.Text,','),0),
                                                      StrToInt64Def(NoSpace(edValorModa.Text,','),0)])
        else
            edEnviaModa.Text := edEnviaModa.Text + Format('%.2d%.12d{%-40s%-40s',[
                                                          StrtoIntDef(NoSpace(edCodModa.Text,','),0),
                                                          StrToInt64Def(NoSpace(edValorModa.Text,','),0),
                                                          edTexto1.Text,
                                                          edTexto2.Text
                                                          ]);
     edCodModa.SetFocus;
end;

procedure TfrmPrincipal.BitBtn17Click(Sender: TObject);
var
   strSub:string;
begin
     if cbAcreSub.Checked then
        strSub := 'S'
        else
            strSub := 'N';

     edRecebido.Text := EnviaComando(Format(#27'.11%.2d%.4d%.11d%s}',[
                                     cbTipoAcr.ItemIndex + 51,
                                     StrToInt(NoSpace(edPctAcre.Text,',')),
                                     StrToInt(NoSpace(edValorAcre.Text,',')),
                                     strSub
                                     ]))
end;

procedure TfrmPrincipal.BitBtn18Click(Sender: TObject);
var
   strVinc,strSeg:String;
begin
     if cbSemPara.Checked then
        begin
             edRecebido.Text := EnviaComando(#27'.12}');
             exit;
        end;

     if cbVinculado.Checked then
        strVinc :='S'
        else
            strVinc :='N';

     if cbSeg.Checked then
        StrSeg :='S'
        else
            StrSeg :='N';


     edRecebido.Text := EnviaComando(Format(#27'.12%s%s%d%-40s%d%-40s%d%-40s%d%-40s%d%-40s%d%-40s%d%-40s%d%-40s}',
                                    [strVinc,strSeg,
                                     StrToIntDef(edAtrib1.Text,0), edLinha1.Text,
                                     StrToIntDef(edAtrib2.Text,0), edLinha2.Text,
                                     StrToIntDef(edAtrib3.Text,0), edLinha3.Text,
                                     StrToIntDef(edAtrib4.Text,0), edLinha4.Text,
                                     StrToIntDef(edAtrib5.Text,0), edLinha5.Text,
                                     StrToIntDef(edAtrib6.Text,0), edLinha6.Text,
                                     StrToIntDef(edAtrib7.Text,0), edLinha7.Text,
                                     StrToIntDef(edAtrib8.Text,0), edLinha8.Text]))
end;

procedure TfrmPrincipal.edAtrib1Exit(Sender: TObject);
begin
     TEdit(Sender).Text := IntToStr(StrToIntDef(TEdit(Sender).Text,0));
end;

procedure TfrmPrincipal.BitBtn19Click(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(Format(#27'.15%.4d%.4d}',[
                                     StrToIntDef(edRedIn.text,0),
                                     StrToIntDef(edRedFin.text,0)]));
end;

procedure TfrmPrincipal.edRedInExit(Sender: TObject);
begin
     TEdit(Sender).Text := FormatFloat('0000',StrToIntDef(TEdit(Sender).Text,0));
end;

procedure TfrmPrincipal.BitBtn20Click(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(Format(#27'.16%.6d%.6d}',[
                                     StrToIntDef(mskDataInicio.Text,0),
                                     StrToIntDef(mskDataFinal.Text,0)]));
end;

procedure TfrmPrincipal.bitCancelaItemClick(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(#27'.04' + edItem.Text  + '}');
     edItem.SetFocus;
end;

procedure TfrmPrincipal.BitBtn22Click(Sender: TObject);
begin
     if EdTitulo.Text = '00' then
        edRecebido.Text := EnviaComando(Format(#27'.19%.2d%.4d%.2d%20s}',[
                                        StrTointDef(edTitulo.Text,0),
                                        StrTointDef(edCOO.Text,0),
                                        StrTointDef(edTipoModal.Text,0),
                                        edIdentificacao.Text]))
        else
            edRecebido.Text := EnviaComando(Format(#27'.19%.2d%4s%.4s%20s}',[
                                            StrTointDef(edTitulo.Text,0),
                                            '',
                                            '',
                                            edIdentificacao.Text]))


end;

procedure TfrmPrincipal.btnEnviaSemParametroClick(Sender: TObject);
begin
     //--> Economizando cdigo.
     edRecebido.Text := EnviaComando(Format(#27'.%.2d}',[TBitBtn(Sender).Tag]))
end;

procedure TfrmPrincipal.BitBtn26Click(Sender: TObject);
begin
     if (rgTipo29.ItemIndex >= 0) and (rgTipo29.ItemIndex < 9) then
     begin
          edRecebido.Text :=  EnviaComando(#27'.29' + IntToStr(rgTipo29.ItemIndex + 1) + '}');
          Exit;
     end
        else
        begin
             edRecebido.Text :=  EnviaComando(#27'.29' + char(rgTipo29.ItemIndex + 56) + '}');
             Exit;
        end;
end;

procedure LimpaCampos(obj:TTabSheet);
var i:Integer;
begin
     for i := 0 to obj.ControlCount -1 do
     begin
          if obj.Controls[i] is TEdit then
             TEdit(obj.Controls[i]).Clear;
          if obj.Controls[i] is TMaskEdit then
             TMaskEdit(obj.Controls[i]).Clear;
     end;
end;

procedure TfrmPrincipal.BitBtn11Click(Sender: TObject);
var
   strLogo,strLiquido:String;
begin
     if cbLogo.Checked then
        strlogo := 'S'
        else
            strlogo := 'N';

     if cbLiquido.Checked then
        strLiquido := 'S'
        else
            strLiquido := 'N';

     edRecebido.Text := EnviaComando(Format(#27'.20%s%s%-15s%s%s}',[
                                     edAtribAut.Text,
                                     strLogo,
                                     edAutCod.Text,
                                     edAutCab.Text,
                                     strLiquido]));
end;

procedure TfrmPrincipal.BitBtn27Click(Sender: TObject);
var
   strVerso:string;
   strDigitos:integer;
begin
     strDigitos := rgDigitosCheque.ItemIndex + 1;
     if cbVersoCheque.Checked then
        strVerso := 'S'
        else
            strVerso := 'N';

     edRecebido.Text := EnviaComando(Format(#27'.24%.3d%.12d%s%-60s%-60s%d%8s}',[
                                     StrToIntDef(edBanco.Text,0),
                                     StrToInt64Def(NoSpace(edValorCheque.Text,','),0),
                                     strVerso,
                                     edLinhaCheque1.text,
                                     edLinhaCheque2.text,
                                     strDigitos,
                                     mskDataCheque.text
                                     ]))
end;

procedure TfrmPrincipal.BitBtn28Click(Sender: TObject);
var
   strCifrao,strCentavos,strTitulo:string;
begin
     if cbCentavos.Checked then
        strCentavos := 'S'
        else
            strCentavos := 'N';

     if cbCifrao.Checked then
        strCifrao := 'S'
        else
            strCifrao := 'N';

     if cbTitulo.Checked then
        strTitulo := 'S'
        else
            strTitulo := 'N';

     edRecebido.Text := EnviaComando(Format(#27'.30%s%.3d%s%s%5s%.4d}',[
                                     strCentavos,
                                     StrToInTDef(edECF.Text,0),
                                     strCifrao,
                                     strTitulo,
                                     edCifrao.text,
                                     StrToIntDef(edIntervalo.text,0)
                                     ]));
end;

procedure TfrmPrincipal.FormCreate(Sender: TObject);
begin
     PageControl1.ActivePageIndex := 0;
end;

procedure TfrmPrincipal.BitBtn29Click(Sender: TObject);
var
   strSegundo:String;
begin
     if cbClicheSegundo.Checked then
        strSegundo := 'S'
        else
            strSegundo := 'N';

     edRecebido.Text := EnviaComando(Format(#27'.31S%d%s%d%-40s%d%-40s%d%-40s%d%-40s%d%-40s}',[
                                     StrToIntDef(edSalto.Text,0),strSegundo,
                                     StrToIntDef(edClicheAtrib1.text,0),edCliche1.Text,
                                     StrToIntDef(edClicheAtrib2.text,0),edCliche2.Text,
                                     StrToIntDef(edClicheAtrib3.text,0),edCliche3.Text,
                                     StrToIntDef(edClicheAtrib4.text,0),edCliche4.Text,
                                     StrToIntDef(edClicheAtrib5.text,0),edCliche5.Text]));
end;

procedure TfrmPrincipal.BitBtn30Click(Sender: TObject);
begin
     edFormatoAliquota.Text := edFormatoAliquota.Text +
                               Format('%-3s%.4d',[edTaxaIdent.text,
                                      StrToIntDef(NoSpace(edAliquota.Text,','),0) ] );
end;

procedure TfrmPrincipal.BitBtn31Click(Sender: TObject);
begin
     edFormatoAliquota.Clear;
end;

procedure TfrmPrincipal.BitBtn32Click(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(#27'.33' + edFormatoAliquota.Text + '}');
end;

procedure TfrmPrincipal.BitBtn33Click(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(Format(#27'.34%-22s%-21s%-16s}',[
                                     edCadCNPJ.Text,
                                     edCadIE.Text,
                                     edCadIM.Text]));
end;

procedure TfrmPrincipal.BitBtn34Click(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(#27'.35'+ mskAcertaHora.Text + mskAcertaData.Text + '}');
end;

procedure TfrmPrincipal.BitBtn35Click(Sender: TObject);
var
   strVerao:String;
begin
     if cbHoraVerao.Checked then
        strVerao := 'S'
        else
            strVerao := 'N';

     edRecebido.Text := EnviaComando(#27'.36' + strVerao + '}')

end;

procedure TfrmPrincipal.BitBtn36Click(Sender: TObject);
begin
     edFormatoNF.Text := edFormatoNF.Text + Format('%-15s',[edLegNF.Text]);
     edLegNF.SetFocus;
end;

procedure TfrmPrincipal.BitBtn38Click(Sender: TObject);
var
   strZera:string;
begin
     if cbZerar.Checked then
        strZera := 'S'
        else
            strZera := 'N';

     edRecebido.Text := EnviaComando(#27'.38'+ strZera + edFormatoNF.Text + '}');
end;

procedure TfrmPrincipal.BitBtn37Click(Sender: TObject);
begin
     edFormatoNF.Clear;
end;

procedure TfrmPrincipal.BitBtn40Click(Sender: TObject);
begin
     edNomeFormatoModa.Text := edNomeFormatoModa.Text + Format('%-15s',[
                                                               edNomeModa.Text]);
end;

procedure TfrmPrincipal.BitBtn41Click(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(#27'.39' + edNomeFormatoModa.Text + '}')
end;

procedure TfrmPrincipal.BitBtn39Click(Sender: TObject);
begin
     edNomeFormatoModa.Clear;
end;

procedure TfrmPrincipal.BitBtn43Click(Sender: TObject);
var strConfirma:String;
begin
     if cbConfirmaComando.Checked then
        strConfirma := 'S'
        else
            strConfirma := 'N';
     edRecebido.Text := EnviaComando(#27'.41' + strConfirma + '}')
end;

procedure TfrmPrincipal.BitBtn45Click(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(Format(#27'.44%-80s%-30s%-20s%-20s}',[
                                     edfavorecido.Text,
                                     edMunicipio.Text,
                                     edMoeda.Text,
                                     edMoedas.Text]))
end;

procedure TfrmPrincipal.BitBtn46Click(Sender: TObject);
var
   strMvalor,strMlinha1, strMlinha2,
   strFavorecido, strMunicipio:string;
begin
     //--> Acrescenta apenas meio line feed para posicionar o valor
     if cbMValor.Checked then
        strMvalor := 'S'
        else
            strMvalor := 'N';

     //--> Acrescenta apenas meio line feed para posicionar primeira
     //--> linha do extenso
     if cbMlinha1.Checked then
        strMlinha1 := 'S'
        else
            strMlinha1 := 'N';

     //--> Acrescenta apenas meio line feed para posicionar primeira
     //--> linha do extenso
     if cbMlinha2.Checked then
        strMlinha2 := 'S'
        else
            strMlinha2 := 'N';

     //--> Acrescenta apenas meio line feed para o nome do favorecido
     if cbMFavorecido.Checked then
        strFavorecido := 'S'
        else
            strFavorecido := 'N';

     //--> Acrescenta apenas meio line feed para a impresso do municpio.
     if cbMMunicipio.Checked then
        strMunicipio := 'S'
        else
            strMunicipio := 'N';

     edRecebido.Text := EnviaComando(Format(#27'.45%3s%1s%1s%2s%1s%1s%2s%1s%1s%2s%1s%1s%2s%1s%1s%2s%2s%2s%2s}',[
                                     edBancoCheque.text,
                                     edLValor.text,strMvalor, edCValor.text,
                                     edExtenso1.text,strMlinha1 , edCextenso1.text,
                                     edExtenso2.text,strMlinha2 , edCextenso2.text,
                                     edLfavorecido.text,strFavorecido, edCfavorecido.text,
                                     edLmunicipio.text, strMunicipio, edCmunicipio.text,
                                     edCdia.text,
                                     edcmes.text,
                                     edcano.text]));
end;

procedure TfrmPrincipal.BitBtn47Click(Sender: TObject);
var
   strBanco:String;
begin
     if cbBanco.Checked then
        strBanco := 'S'
        else
            strbanco := 'N';

     edRecebido.Text := EnviaComando(#27'.46' + strBanco + ednumero.Text + '}' );
end;

procedure TfrmPrincipal.BitBtn48Click(Sender: TObject);
var
   strTipo:string;
begin
     case rgNF.ItemIndex of
          0: strTipo := '+';
          1: strTipo := '=';
          2: strTipo := '-';
     end;
     edFormatoNF47.Text := edFormatoNF47.Text + Format('%s%-15s%-15s%-15s',[
                                                       strTipo,edTituloNF.text,
                                                       edLegNF47.Text,
                                                       edNovaLeg47.text]);
end;

procedure TfrmPrincipal.BitBtn49Click(Sender: TObject);
begin
     edFormatoNF47.Clear;
end;

procedure TfrmPrincipal.BitBtn50Click(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(#27'.47' + edFormatoNF47.Text + '}');
end;

procedure TfrmPrincipal.BitBtn51Click(Sender: TObject);
var
   strImediata,
   strAbrevia,
   strBidi,
   strTroco:string;
begin
     if cbImediata.Checked then
        strImediata := 'S'
        else
            strImediata := 'N';

     if cbAbrev.Checked then
        strAbrevia := 'S'
        else
            strAbrevia := 'N';

     if cbBidi.Checked then
        strBidi := 'S'
        else
            strBidi := 'N';

     if cbTroco.Checked then
        strTroco := 'S'
        else
         strTroco := 'N';

     edRecebido.Text := EnviaComando(#27'.50'+ strImediata + strAbrevia +
                                     strBidi + strTroco + '}');
end;

procedure TfrmPrincipal.BitBtn53Click(Sender: TObject);
var
   strtira:string;
begin
     //--> tira os espaos (20) ao final da definio hexadecimal do logotipo.
     frmLogo := TfrmLogo.Create(nil);
     frmLogo.ShowModal;
     frmLogo.Release;
     strtira := edFormatoLogo.Text;
     while Copy(strtira,length(strtira)- 1,2) = '20' do
           Delete(strtira,length(strtira)-1,2);
     edFormatoLogo.Text := strtira;
end;

procedure TfrmPrincipal.BitBtn52Click(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(#27'.40'+ format('%.3d',[length(edFormatoLogo.Text)])+ edFormatoLogo.Text + '}');
end;

procedure TfrmPrincipal.BitBtn54Click(Sender: TObject);
begin
     edFormatoIndic.Text := edFormatoIndic.Text + '|' + edTipoIndic.Text + edIdentIndic.Text;
end;

procedure TfrmPrincipal.BitBtn55Click(Sender: TObject);
begin
     edFormatoIndic.Clear;
end;

procedure TfrmPrincipal.BitBtn56Click(Sender: TObject);
begin
     edRecebido.Text := EnviaComando(#27'.09|' + edAtribIndic.Text + edFormatoIndic.Text + '}')
end;

end.

//******************************************************************************
//*                          End of File uPrincipal.pas
//******************************************************************************
